# Ogre::GLHardwareVertexBuffer Class Reference

Specialisation of HardwareVertexBuffer for OpenGL. More...

`#include <OgreGLHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::GLHardwareVertexBuffer:

List of all members.

## Public Types

enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE }
| Locking options. More...

## Public Member Functions

| GLHardwareVertexBuffer (size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage, bool useShadowBuffer)
| ~GLHardwareVertexBuffer ()
void | readData (size_t offset, size_t length, void *pDest)
| See HardwareBuffer.
void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| See HardwareBuffer.
GLuint | getGLBufferId (void) const
size_t | getVertexSize (void) const
| Gets the size in bytes of a single vertex in this buffer.
size_t | getNumVertices (void) const
| Get the number of vertices in this buffer.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void | unlock (void)
| Releases the lock on this buffer.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.

## Protected Member Functions

void * | lockImpl (size_t offset, size_t length, LockOptions options)
| See HardwareBuffer.
void | unlockImpl (void)
| See HardwareBuffer.

## Protected Attributes

size_t | mNumVertices
size_t | mVertexSize
size_t | mSizeInBytes
Usage | mUsage
bool | mIsLocked
size_t | mLockStart
size_t | mLockSize
bool | mSystemMemory
bool | mUseShadowBuffer
HardwareBuffer * | mpShadowBuffer
bool | mShadowUpdated
bool | mSuppressHardwareUpdate

## Private Attributes

GLuint | mBufferId

## Detailed Description

Specialisation of HardwareVertexBuffer for OpenGL.

Definition at line 34 of file OgreGLHardwareVertexBuffer.h.

## Member Enumeration Documentation

enum Ogre::HardwareBuffer::LockOptions `[inherited]`

Locking options.

Enumeration values:

  HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
  HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
  HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on statuc buffers, ie those created without the HBU_DYNAMIC flag.
  HBL_NO_OVERWRITE | As HBL_NORMAL, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.

Definition at line 111 of file OgreHardwareBuffer.h.

enum Ogre::HardwareBuffer::Usage `[inherited]`

Enums describing buffer usage; not mutually exclusive.

Enumeration values:

  HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
  HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
  HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.

  HBU_DISCARDABLE

  Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated.

  This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.

  HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
  HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
  HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

Definition at line 69 of file OgreHardwareBuffer.h.

## Constructor & Destructor Documentation

Ogre::GLHardwareVertexBuffer::GLHardwareVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer
| ) |

Ogre::GLHardwareVertexBuffer::~GLHardwareVertexBuffer | ( |  | ) |

## Member Function Documentation

virtual void Ogre::HardwareBuffer::_updateFromShadow | ( | void |  | ) | `[virtual, inherited]`

| Updates the real buffer from the shadow buffer, if required. Definition at line 275 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = false
| ) | `[virtual, inherited]`

Copy data from another buffer into this one.

Remarks:
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters:

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Definition at line 265 of file OgreHardwareBuffer.h.

References Ogre::HardwareBuffer::lock(), and Ogre::HardwareBuffer::unlock().

GLuint Ogre::GLHardwareVertexBuffer::getGLBufferId | ( | void |  | ) | const

| Definition at line 54 of file OgreGLHardwareVertexBuffer.h.

size_t Ogre::HardwareVertexBuffer::getNumVertices | ( | void |  | ) | const`[inherited]`

| Get the number of vertices in this buffer. Definition at line 51 of file OgreHardwareVertexBuffer.h.

size_t Ogre::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const`[inherited]`

| Returns the size of this buffer in bytes. Definition at line 300 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::getUsage | ( | void |  | ) | const`[inherited]`

| Returns the Usage flags with which this buffer was created. Definition at line 302 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareVertexBuffer::getVertexSize | ( | void |  | ) | const`[inherited]`

| Gets the size in bytes of a single vertex in this buffer. Definition at line 49 of file OgreHardwareVertexBuffer.h.

bool Ogre::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const`[inherited]`

| Returns whether this buffer has a system memory shadow for quicker reading. Definition at line 306 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isLocked | ( | void |  | ) | const`[inherited]`

| Returns whether or not this buffer is currently locked. Definition at line 308 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isSystemMemory | ( | void |  | ) | const`[inherited]`

| Returns whether this buffer is held in system memory. Definition at line 304 of file OgreHardwareBuffer.h.

void* Ogre::HardwareBuffer::lock | ( | LockOptions | options | ) | `[inherited]`

Lock the entire buffer for (potentially) reading / writing.

Parameters:

  options | Locking options

Returns:
  Pointer to the locked memory

Definition at line 201 of file OgreHardwareBuffer.h.

virtual void* Ogre::HardwareBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) | `[virtual, inherited]`

Lock the buffer for (potentially) reading / writing.

Parameters:

  offset | The byte offset from the start of the buffer to lock
  length | The size of the area to lock, in bytes
  options | Locking options

Returns:
  Pointer to the locked memory

Reimplemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, Ogre::HardwarePixelBuffer, Ogre::GLDefaultHardwareVertexBuffer, and Ogre::GLDefaultHardwareIndexBuffer.

Definition at line 171 of file OgreHardwareBuffer.h.

Referenced by Ogre::HardwareBuffer::copyData().

void* Ogre::GLHardwareVertexBuffer::lockImpl | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) | `[protected, virtual]`

| See HardwareBuffer. Implements Ogre::HardwareBuffer.

void Ogre::GLHardwareVertexBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest
| ) | `[virtual]`

| See HardwareBuffer. Implements Ogre::HardwareBuffer.

void Ogre::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) | `[inherited]`

| Pass true to suppress hardware upload of shadow buffer changes. Definition at line 312 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::unlock | ( | void |  | ) | `[virtual, inherited]`

Releases the lock on this buffer.

Remarks:
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, Ogre::GLDefaultHardwareVertexBuffer, and Ogre::GLDefaultHardwareIndexBuffer.

Definition at line 217 of file OgreHardwareBuffer.h.

Referenced by Ogre::HardwareBuffer::copyData().

void Ogre::GLHardwareVertexBuffer::unlockImpl | ( | void |  | ) | `[protected, virtual]`

| See HardwareBuffer. Implements Ogre::HardwareBuffer.

void Ogre::GLHardwareVertexBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = false
| ) | `[virtual]`

| See HardwareBuffer. Implements Ogre::HardwareBuffer.

## Member Data Documentation

GLuint Ogre::GLHardwareVertexBuffer::mBufferId `[private]`

| Definition at line 37 of file OgreGLHardwareVertexBuffer.h.

bool Ogre::HardwareBuffer::mIsLocked `[protected, inherited]`

| Definition at line 133 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockSize `[protected, inherited]`

| Definition at line 135 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockStart `[protected, inherited]`

| Definition at line 134 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareVertexBuffer::mNumVertices `[protected, inherited]`

| Definition at line 40 of file OgreHardwareVertexBuffer.h.

HardwareBuffer* Ogre::HardwareBuffer::mpShadowBuffer `[protected, inherited]`

| Definition at line 138 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mShadowUpdated `[protected, inherited]`

| Definition at line 139 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mSizeInBytes `[protected, inherited]`

| Definition at line 131 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSuppressHardwareUpdate `[protected, inherited]`

| Definition at line 140 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSystemMemory `[protected, inherited]`

| Definition at line 136 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::mUsage `[protected, inherited]`

| Definition at line 132 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mUseShadowBuffer `[protected, inherited]`

| Definition at line 137 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareVertexBuffer::mVertexSize `[protected, inherited]`

| Definition at line 41 of file OgreHardwareVertexBuffer.h.

The documentation for this class was generated from the following file:

- OgreGLHardwareVertexBuffer.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:46:40 2005